<?php
/**
 * Borrow Manager
 *
 * Handles lending of disks
 *
 * @package videoDB
 * @author  Andreas Gohr <a.gohr@web.de>
 * @version $Id: borrow.php,v 2.14 2005/08/26 14:47:46 chinamann Exp $
 */

require_once './core/functions.php';

// check for localnet
localnet_or_die();

// permission check
permission_or_die(PERM_WRITE); 

// borrowmanagement for single disk
$editable = false;
if (!empty($diskid))
{
    if (check_permission(PERM_WRITE, get_owner_id($diskid,true)))
	{
		$editable = true;
		if ($return) {
            $DELETE = "DELETE FROM ".TBL_LENT." WHERE diskid = '".addslashes($diskid)."'";
			runSQL($DELETE);
		}
		if (!empty($who)) {
			$who = addslashes($who);
            $INSERT = "INSERT INTO ".TBL_LENT." SET who = '".addslashes($who)."', diskid = '".addslashes($diskid)."'";
			runSQL($INSERT);
		}

		$SELECT = "SELECT who, DATE_FORMAT(dt,'%d.%m.%Y') AS dt 
                     FROM ".TBL_LENT." 
                    WHERE diskid = '".addslashes($diskid)."'";
		$result = runSQL($SELECT);
		
		$who = $result[0]['who'];
		$dt  = $result[0]['dt'];
	}
}

$all = strtoupper($lang['radio_all']);
$WHERES = "";

if ($config['multiuser']) 
{    
    if (empty($owner_id)) 
    {
        // explicit setting of owner
        if ($_SESSION['vdb']['owner'] && ($_SESSION['vdb']['owner'] == $all || check_permission(PERM_READ,$uid = getUserId($_SESSION['vdb']['owner'])))) {
            if($_SESSION['vdb']['owner'] == $all) $uid = -1; 
                $owner_id = $uid;
        } 
        elseif (check_permission(PERM_READ,$_COOKIE['VDBuserid'])) 
        { 
            $owner_id = $_COOKIE['VDBuserid'];
        } 
        elseif (count($owners = out_owners(false,PERM_READ,true)) == 1) 
        { 
            // check if there is only one owner available
            $owners = array_keys($owners);
            $owner_id = $owners[0];
        } 
        else 
        {
            // help! take ALL
            $owner_id = -1;
        }
    }
        
    if ($owner_id && $owner_id >= 0) $_SESSION['vdb']['owner'] = getUserName($owner_id);
    else $_SESSION['vdb']['owner'] = $all;

    if ($owner_id < 0) // All
    {
        $WHERES .= " AND B.owner_id IN (".owners2list(out_owners(null, PERM_READ, true), false).")";
    } 
    else 
    {   // User
        $WHERES .= " AND B.owner_id = '".$owner_id."'";
    }
}


// overview on lent disks
$SELECT = "SELECT who, DATE_FORMAT(dt,'%d.%m.%Y') as dt, A.diskid,
		          CASE WHEN B.subtitle = '' THEN B.title ELSE CONCAT(B.title,' - ',B.subtitle) END AS title,
                  B.id, COUNT(A.diskid) AS count, Busers.name AS owner
             FROM ".TBL_LENT.' A, '.TBL_DATA.' B
        LEFT JOIN '.TBL_USERS.' Busers ON B.owner_id = Busers.id
            WHERE A.diskid = B.diskid '.$WHERES.'
         GROUP BY A.diskid
         ORDER BY who, A.diskid';
$result = runSQL($SELECT);

// check permissions
for($i=0; $i < count($result); $i++)
{
    $result[$i]['editable'] = check_permission(PERM_WRITE, getUserId($result[$i]['owner']));
}

// prepare templates
tpl_page();

if ($config['multiuser'])
{
    $smarty->assign('owners', out_owners(array('-1' => $all),PERM_READ,true));
    $smarty->assign('owner_id', $owner_id);
}

$smarty->assign('diskid', $diskid);
$smarty->assign('who', $who);
$smarty->assign('dt',  $dt);
$smarty->assign('editable',   $editable);
$smarty->assign('borrowlist', $result);

// display templates
tpl_display('borrow.tpl');

?>
