<?php
/**
 * Global config file
 *
 * Sets database connection Strings and debug option
 *
 * @package Setup
 * @author  Andreas Gohr <a.gohr@web.de>
 * @version $Id: config.inc.php,v 2.49 2005/10/21 10:32:25 chinamann Exp $
 */

/* Database options */
$config['db_server']    = 'localhost';  // database server
$config['db_user']      = 'www';        // DB user for connection
$config['db_password']  = 'leech';      // password for above user
$config['db_database']  = 'VideoDB';    // Database name
$config['db_prefix']    = '';           // Database table prefix (for use in hosting environments)

/* Amazon developer token */
$config['amazontoken']	= '';			// get your own amazon developer token to use the amazonxml module

/* Debug option */
$config['debug']        = 0;            // Usually leave this at 0

/* Logging */
$config['httpclientlog']= 0;            // HttpClient logging

/* Lookup external data default */	
$config['lookupdefault_edit'] = 0;		// 0=ignore, 1=lookup, 2=overwrite
$config['lookupdefault_new']  = 2;		// 0=ignore, 1=lookup, 2=overwrite

/* XML Import/Export */
$config['xml'] = 0;                     // Set to 1 to enable XML data im/export - import requires php5

/* RSS Feed */
$config['rss'] = 1;                     // Set to 1 to enable RSS Feed

/* Configuration Table */
$config['conf_table']	= 'config';     // Table holding configuration

/* Hierarchical cache folders */
$config['hierarchical']	= 0;            // Set to 1 to enable hierarchical cache folders (if existing!)

/*
 * To enable PDF export you can uncomment the following line and edit 
 * the settings in pdf.inc.php. This option requires the additional installation
 * of FPDF downloadable from http://www.fpdf.org
 */
// require_once 'pdf.inc.php';

/*
 * To enable XLS export you can uncomment the following line and edit 
 * the settings in xls.inc.php. This option requires the additional installation
 * of "Spreadsheet OLE" and "Spreadsheet Excel Writer". They have to be accessible 
 * from the "include_path" which is set inside "php.ini".
 * 
 * In the Apache Distribution XAMPP it is included by default.
 * On gentoo linux systems you can easily add it by typing 
 *     emerge dev-php/PEAR-Spreadsheet_Excel_Writer
 *  
 * Official Website:
 * http://pear.php.net/package/Spreadsheet_Excel_Writer/
 */
// require_once 'xls.inc.php';

/* 
 * If you're running videodb over a low bandwidth connection with many users
 * you can uncomment the following line and edit the settings in thumbs.inc.php
 * to enable creation of smaller thumbnails. This option requires additional 
 * installation of phpThumb downloadable from http://phpthumb.sourceforge.net
 */
// require_once 'thumbs.inc.php';

/* 
 * Amount of digits which are automatically generated as DiskID
 * if "Automatic DiskID" is enabled in the configuration tab
 */
$config['diskid_digits'] = 4;

/*
 *  To get access to FSK18 rated movies in the german dvdb engine you
 *  have to enter your dvdb user id and password. If you don't have a 
 *  user you can go to http://www.dvdb.de and click on 'Neu registrieren'.
 *  Don't forget to enter the identification card id to get FSK18 access!
 * */
$config['dvdb_user']     = '';
$config['dvdb_password'] = '';

?>
