<?php
/**
 * TV.com importer
 *
 * @package Contrib
 * @author  Andreas Gohr <agohr@web..de>
 * @version $Id: tvtome.php,v 2.15 2006/01/06 11:08:01 andig2 Exp $
 */

// move out of contrib for includes
chdir('..');

require_once './core/functions.php';
require_once './core/httpclient.php';
require_once './engines/engines.php';

localnet_or_die();
permission_or_die(PERM_ADMIN);

error_reporting(E_ALL^E_NOTICE);

?>

<html>
<head>
  <title>TV.com importer</title>
</head>
<body>

<?
if ($save)
{
    save();
}
else
{
    printStartForm();
    if (!empty($tomeurl) && !empty($titlesql))
    {
        printEpisodes($tomeurl,$titlesql,$showext);
    }
}
?>

</body>
</html>


<?
// -------------- Functions follow -------------

function printStartForm()
{
  global $tomeurl;
  global $titlesql;
  global $showext;
  ?>
  <form method="post">
  <table>
    <tr>
      <td>TV.com EpisodeGuide</td>
      <td><input type="text" name="tomeurl" value="<?=formvar($tomeurl)?>"></td>
      <td>e.g. <code>http://www.tv.com/futurama/show/249/episode_guide.html</code> (See <a href="http://www.tv.com" target="_blank">tv.com</a>)</td> 
    </tr>
    <tr>
      <td>VideoDB Titlesearch</td>
      <td><input type="text" name="titlesql" value="<?=formvar($titlesql)?>"></td>
      <td>e.g. <code>Futurama*</code> - Very simple search use * and ? as wildcards.</td>
    </tr>
    <tr>
      <td>Show additional information</td>
  <?
    if (stristr(formvar($showext), 'showext')) {
  ?>
      <td><input type="checkbox" name="showext" value="showext" checked></td>
  <?
    } else {
  ?>
      <td><input type="checkbox" name="showext" value="showext"></td>
  <?
    }
  ?>
      <td>Actors and Directors are shown</td>
    </tr>
    <tr>
      <td colspan="2" align="center">
        <input type="submit">
      </td>
      <td></td>
    </tr>
  </table>
  </form>
  
  <br><br><hr><br><br>
  <?
}

function printEpisodes($tomeurl,$titlesql,$showext)
{
    // url contains unique id
    if (!stristr($tomeurl, 'http://')) {
        echo "Need full URL!";
    }
    
    // fetch data
    $episodes = fetchTomeInfos($tomeurl);
    $videos = getVideoIDs($titlesql);

?>
  <form method="post">
    <input type="hidden" name="save" value="1"/>
    
  <table>
  <?
    $row=0;
    foreach ($episodes as $ep)
{
  ?>
    <tr>
      <td>
        <input id="<?=$ep[number]?>" type="checkbox" name="form_eps[]" value="<?=$row?>">
        <?=$ep[number]?>: <?=$ep[title]?>
      </td>
      <td>
        <select name="form_id[<?=$row?>]">
        <?showSelect($videos,$ep[title])?>
        </select>
      </td>
    </tr>
    <tr>
    </tr>
    <tr>
      <td>
  <?
    if ($showext) {
  ?>
         Director: 
         <?=substr($ep[director],0,250)?>   
      </td>
    </tr>
    <tr>
      <td>
         Actors: 
         <?=substr($ep[actors],0,250)?>   
      </td>
    </tr>
    <tr>
      <td>
         Plot:<br>
  <?
    }
  ?>
         <?=substr($ep[plot],0,250)?>...
      </td>
    </tr>
    <tr>
      <td>
        <input type="hidden" name="form_title[<?=$row?>]" value="<?=formvar($ep[title])?>">
        <input type="hidden" name="form_plot[<?=$row?>]" value="<?=formvar($ep[plot])?>">
        <input type="hidden" name="form_year[<?=$row?>]" value="<?=formvar($ep[year])?>">
        <input type="hidden" name="form_actors[<?=$row?>]" value="<?=formvar($ep[actors])?>">
        <input type="hidden" name="form_director[<?=$row?>]" value="<?=formvar($ep[director])?>">
      </td>
    </tr>
    <tr>
    <td colspan="2"><hr></td>
    </tr>
  <?
    $row++;
    }
  ?>
  </table>
    
  <center>
    <input type="submit">
  </center>
  </form>
  <?
}

function similarity($string1,$string2)
{
  $string1 = preg_replace('/[^a-zA-Z ]/','',$string1);
  $string2 = preg_replace('/[^a-zA-Z ]/','',$string2);
  $string1 = strtolower($string1);
  $string2 = strtolower($string2);
  similar_text($string1,$string2,$sim);
  if (strstr($string1,$string2)) return 100;
  if (strstr($string2,$string1)) return 100;
  return number_format($sim, 0);
}

function showSelect($videos,$select)
{

  print '<option value=""></option>';
  foreach($videos as $vid){
    $thissim = 0;
    $sim = similarity($select,$vid[title]);
    if ($sim > $thissim) $thissim = $sim;
    $sim = similarity($select,$vid[subtitle]);
    if ($sim > $thissim) $thissim = $sim;
    $sim = similarity($select,$vid[filename]);
    if ($sim > $thissim) $thissim = $sim;
    
    if ($thissim >= 60 ){
      $SEL = "selected";
    }else{
      $SEL = "";
    }
    
    print '<option value="'.$vid[id].'" '.$SEL.'>';
    print $vid[title];
    print ' - ';
    print $vid[subtitle];
    print '   ('.$thissim.'%)';
    print '</option>';
  }
}

function save()
{
  global $form_eps;
  global $form_id;
  global $form_title;
  global $form_plot;
  global $form_year;
  global $form_actors;
  global $form_director;
  
  print '<h2>Updating Videoinfos...</h2>';
  
  foreach($form_eps as $ep){
    $id    = $form_id[$ep];    
    if (empty($id)) continue;
    $title = addslashes($form_title[$ep]);
    $plot  = addslashes($form_plot[$ep]);
    $year  = addslashes($form_year[$ep]);
    $actors  = addslashes($form_actors[$ep]);
    $director = addslashes($form_director[$ep]);

    print $form_title[$ep].'... ';    
    $SQL = "UPDATE videodata
               SET plot = '$plot',
                   year = '$year',
                   actors = '$actors',
                   director = '$director',
                   istv = 1,
                   lastupdate = NOW()
             WHERE id = $id";
    runSQL($SQL);
    print "done.<br>";
  }
  
  print '<p><a href="..">back to videodb</a></p>';
}

function getVideoIDs($title)
{
  $title = addslashes($title);
  $title = preg_replace('/\*/','%',$title);
  $title = preg_replace('/\?/','_',$title);
  $SQL = "SELECT id, title, subtitle, filename
            FROM videodata
           WHERE LOWER(title) LIKE LOWER('$title')
        ORDER BY title, subtitle";
  $result = runSQL($SQL);
  return $result;
}

function fetchTomeInfos($url)
{
  $response = httpClient($url, true);
  //get the main body
  preg_match('/<div id="episode_guide" class="pod">(.*?)<div id="showspace_foot" class="pod">/si', $response[data], $matches);

  $body = $matches[1];
  // get season
//  preg_match('//si','',$body,$match);

  //get episodes
  preg_match_all('/<h1>(<a href=".*?" class="f-big">.*?<\/a>.*?<div class="divider fl"><\/div>)/si',$body,$matches,PREG_PATTERN_ORDER);

  $ep=0;
  $episodes=array();
  //get infos;
  foreach($matches[1] as $episode){

    preg_match_all('/<a href="(.*?)" class="f-big">\s*(.*)<\/a> <span class=/si',$episode,$fields);
    
    //title and episodenumber
    preg_match('/\s*(\d*)\.\s*(.*)/',$fields[2][0],$match);
    $episodes[$ep][number]=$match[1];
    $episodes[$ep][title]=$match[2];
    $episodes[$ep][url]=$fields[1][0];
    
    //gueststars
    preg_match('/<span class="f-bold">Guest star:<\/span>(.*?)<br\/>.*?<\/div>/si',$episode,$gbody);
    preg_match_all('/<a href="http:\/\/www.tv.com\/.*?\/person\/.*?\/summary.html">\s*(.*?)<\/a>( \s*\((.*?)\))?/si',$gbody[0],$gss,PREG_SET_ORDER);

    $actors = '';
    foreach($gss as $gs){
      $actors .= $gs[1];
      $actors .= '::';
      if(preg_match('/Voice of /',$gs[2])){
        $gs[2] = preg_replace('/Voice of /','',$gs[2]);
        $gs[2] .= ' (Voice)';
      }
      $actors .= $gs[3];
      $actors .= "\n";
    }
    $episodes[$ep][actors]=trim($actors);
    
    //plot
    preg_match('/<p>(.*?)<\/p>/si',$episode,$match);
    $episodes[$ep][plot]=trim(strip_tags($match[1]));
    
    //year
    preg_match('/<span class="f-bold">First aired.*?\/(\d{4})<\/span>/si',$episode,$match);
    $episodes[$ep][year]=$match[1];
    
    //Director
    preg_match('/<span.*?>Director.*?<a href=.*?>(.*?)<\/a>/si',$episode,$match);
    $episodes[$ep]['director']=trim($match[1]);
    
    $ep++;
  }
  return $episodes;
}

?>

