<?php
/**
 * Constants
 *
 * Contains global constants for table names
 * Must only be loaded after config.inc.php
 *
 * @package Core
 * @author  Andreas Goetz   <cpuidle@gmx.de>
 * @version $Id: constants.php,v 1.14 2006/03/10 19:39:23 andig2 Exp $
 */

// Config file
define ('CONFIG_FILE', './config.inc.php');
define ('VERSION', '2.2.1');

// User Permission bit masks
define('PERM_ADMIN', 1);
define('PERM_READ',  2);
define('PERM_WRITE', 4);
define('PERM_ADULT', 8);

// Cache folders
define('CACHE_IMG', 'img');
define('CACHE_HTML', 'imdb');

// Table names
define('TBL_DATA',          $config['db_prefix'].'videodata');

define('TBL_CONFIG',        $config['db_prefix'].
                            (empty($config['conf_table']) ? 'config' : $config['conf_table']));
define('TBL_USERCONFIG',    $config['db_prefix'].'userconfig');

define('TBL_USERS',         $config['db_prefix'].'users');
define('TBL_USERSEEN',      $config['db_prefix'].'userseen');
define('TBL_PERMISSIONS',   $config['db_prefix'].'permissions');

define('TBL_ACTORS',        $config['db_prefix'].'actors');
define('TBL_GENRES',        $config['db_prefix'].'genres');

define('TBL_VIDEOGENRE',    $config['db_prefix'].'videogenre');
define('TBL_MEDIATYPES',    $config['db_prefix'].'mediatypes');

define('TBL_LENT',          $config['db_prefix'].'lent');

// Wishlist
define('MEDIA_WISHLIST', 50);

// Amazon token
define('AMAZON_TOKEN', 'cpuidle-20');

// Required database version
define('DB_REQUIRED', 17);

?>