<?php
/**
 * XML support functions
 *
 * @package Core
 * @author  Andreas Gtz    <cpuidle@gmx.de>
 * @version $Id: xml_functions.php,v 1.1 2005/11/16 16:23:37 andig2 Exp $
 */
 
/**
 * Encodes HTML entities into XML character entities
 * this avoids problems with unknown entities in XML
 *
 * @param   string  $string HTML string to encode
 * @return  string          encoded string containing XML character entities  
 */
function encode_character_entities($string)
{
    return strtr($string, get_html_translation_table(HTML_SPECIALCHARS));
#   return strtr($string, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
}

/**
 * Create an XML tag
 *
 * @param   string  $tag    XML tag name
 * @param   string  $value  value for XML tag
 * @param   boolean $encode require encoding of tag value
 * @return  string          XML tag
 */
function createTag($tag, $value, $encode = true)
{
    if ($encode) $value = encode_character_entities($value);
    return "<$tag>".$value."</$tag>\n";
}

function createContainer($tag, $value = '')
{
    return createTag($tag, $value, false);
}

/**
 * Convert MySQL Date to RSS timestamp
 */
function rss_timestamp($timestamp)
{
    // Lets sort this nasty timestamp nonsense out ;D
/*
//  this seems broken- not sure why or if this ever worked...
    $y          = substr($timestamp, 0, 4);
    $m          = substr($timestamp, 4, 2);
    $d          = substr($timestamp, 6, 2);
    $h          = substr($timestamp, 8, 2);
    $min        = substr($timestamp, 10, 2);
    $s          = substr($timestamp, 12, 2);
*/
    $y          = substr($timestamp, 0, 4);
    $m          = substr($timestamp, 5, 2);
    $d          = substr($timestamp, 8, 2);
    $h          = substr($timestamp, 11, 2);
    $min        = substr($timestamp, 14, 2);
    $s          = substr($timestamp, 17, 2);

    $timestamp  = mktime($h, $min, $s, $m, $d, $y);

    return date('D, j M Y G:i:s T', $timestamp);
}

?>
