<?php
/**
 * Google Image Parser
 *
 * Lookup cover images from Google
 *
 * @package Engines
 * @author  Andreas Gtz    <cpuidle@gmx.de>
 * @link    http://images.google.com  Google image search
 * @version $Id: google.php,v 1.3 2005/02/23 20:32:16 andig2 Exp $
 */

$GLOBALS['googleServer']	= 'http://images.google.com';

/**
 * Get meta information about the engine
 *
 * @todo    Include image search capabilities etc in meta information
 */
function googleMeta()
{
    return array('name' => 'Google', 'stable' => 1);
}

/**
 * Search an image on Google
 *
 * Searches for a given title on the google and returns the found links in
 * an array
 *
 * @param   string    The search string
 * @return  array     Associative array with id and title
 */
function googleSearch($title)
{

    global $googleServer;
    global $CLIENTERROR;

    $resp = httpClient($googleServer.'/images?q='.urlencode($title), 1);
    if (!$resp['success']) $CLIENTERROR .= $resp['error']."\n";

/*
    typical google link:
    
    <a href=/imgres?imgurl=http://citaya.dyndns.org/~citaya/JapanesePosters/C/CrimsonRivers2.gif
                &imgrefurl=http://citaya.dyndns.org/~citaya/Latest/LatestMenu.html
                &h=215&w=150&sz=28&tbnid=u0-WCuD0rscJ:&tbnh=100&tbnw=70&start=9&prev=/images%3Fq%3DCrimson%2BRivers%2B2%26hl%3Dde%26lr%3D%26ie%3DUTF-8>
        <img src=/images?q=tbn:u0-WCuD0rscJ:citaya.dyndns.org/~citaya/JapanesePosters/C/CrimsonRivers2.gif width=70 height=100>
    </a>
*/

    $result = array();
    if (preg_match_all('#/imgres\?imgurl=(.+?)&.+?<img src=(.+?)\swidth=(\d+).+?height=(\d+)#', $resp['data'], $data, PREG_SET_ORDER))
    {
        foreach ($data as $row) 
        {
            $info = array();
            $info['title']      = $row[3].'x'.$row[4];      // width x height
            $info['imgsmall']   = $googleServer.$row[2];    // small thumbnail url
            $info['coverurl']   = $row[1];                  // resulting target url
            $result[]           = $info;
        }
    }
    
    return $result;
}

?>