<?php
/**
 * Image loader
 *
 * Loads an image from the net and creates a chachefile for it.
 *
 * @package videoDB
 * @author  Andreas Gohr    <a.gohr@web.de>
 * @version $Id: img.php,v 2.20 2006/01/01 13:37:57 andig2 Exp $ 
 */

require_once './core/functions.php';
require_once './core/httpclient.php';
require_once './engines/imdb.php';

/* 
 * Note:
 *
 * We don't clear overage thumbnails. Instead, 
 * the table entries will be replaced when an image is finally available
 */

// since we don't need session functionality, use this as workaround 
// for php bug #22526 session_start/popen hang 
session_write_close();

/**
 * amazon workaround for 1 pixel transparent images
 */
function checkAmazonSmallImage($url, $ext, $file)
{
	if (preg_match('/^(.+)L(Z{7,}.+)$/', $url, $m)) 
    {
		list($width, $height, $type, $attr) = getimagesize($file);
		if ($width <= 1) 
        {
			$smallurl = $m[1].'M'.$m[2];
#			if (checkCacheFile($smallurl, $ext, $smallfile) || download($smallurl, $smallfile))
            if (cache_file_exists($smallurl, $cache_file, 'img', $ext) || 
                download($smallurl, $cache_file))
            {
                copy($cache_file, $file);
			}
		}
	}
}

// Get imgurl for the actor
if ($name) 
{
    // name given
	$name   = html_entity_decode($name);
	$result = imdbActor($name, $actorid);
	$url    = $result[0][1];

	if (preg_match('/nohs(-[f|m])?.gif$/', $url)) 
    {
        // imdb no-image picture
		$url = '';
	} 

    // write actor last checked record
    {
        // write only if HTTP lookup physically successful
        $SQL = 'REPLACE '.TBL_ACTORS." (name, imgurl, actorid, checked)
                 VALUES ('".addslashes($name)."', '".addslashes($url)."', '".addslashes($actorid)."', NOW())";
        runSQL($SQL);
    }
}

// Get cached image for the given url
if (preg_match('/\.(jpe?g|gif|png)$/i', $url, $matches))
{
	// determine mime type
	switch (strtolower($matches[1]))
	{
		case 'gif':	$mime = 'image/gif';
					break;
		case 'png':	$mime = 'image/png';
					break;
		default:	$mime = 'image/jpeg';
	}

	// does the cache file exist?
#	if (checkCacheFile($url, $matches[1], $file)) 
    if (cache_file_exists($url, $file, 'img', $matches[1]))
    {  
		// cache exists
		$data = $file;
		// amazon workaround for 1 pixel transparent images
		checkAmazonSmallImage($url, $matches[1], $file);
	} 
    // no, download successful?
    elseif (download($url, $file)) 
    {
		// cache created
		$data = $file;
	} 
    // no, use default image instead
    else 
    {
		// cache creation failed
		$mime = 'image/gif';
		$data = img('nocover.gif');
	}
} 
else 
{
	// no url given -> nopic
	$mime = 'image/gif';
	$data = img('nocover.gif');
}

header('Content-type: '.$mime);
readfile($data);

?>
