<?php
/**
 * Thumbnail configuration file for phpThumb
 *
 * Installation
 *
 * 1)   add the following line to the phpthumb.config.php file,
 *      be sure to replace /videodb with your videodb folder
 *
 *      $PHPTHUMB_CONFIG['cache_directory'] = $_SERVER['DOCUMENT_ROOT'].'/videodb/cache/thumbs/'; 
 *
 * 2)   create the cache/thumbs folder and make sure it's writable
 *
 * 3)   modify the following settings to enable thumbnail generation
 *
 * @package Setup
 * @author  Andreas Goetz <cpuidle@gmx.de>
 * @link    http://phpthumb.sourceforge.net
 * @version $Id: thumbs.inc.php,v 2.3 2004/09/20 15:15:41 andig2 Exp $
 */

// path to phpThumb
//	    enter the path to phpThumb.php (include trailing slash)
//	    leave empty to disable thumbnail creation
$config['thumbnail_module']	= '../modules/phpThumb/';

// define when thumbs are created
//	    -1	create thumbnails for all images
//	     0	only create thumbnails when requested image dimensions are smaller than original image
//     ddd	use any positive integer to create thumbnail when existing file has size bigger than ddd
$config['thumbnail_level'] 	= 6000;

// JPEG compression quality of created thumbnails
//	    dd	use positive integer between 0 and 100 to define quality level
//	    	leave empty for phpThumb default quality (75)
$config['thumbnail_quality']	= 75;

?>
